# Hints

## General

- The [csharp.net strings tutorial][tutorial-csharp.net-strings] has a nice introduction to C# `string`s.
- The `string` class has many useful [built-in methods][docs-string-methods].

## 1. Get message from a log line

- Different options to search for text in a string are explored in [this tutorial][tutorial-docs.microsoft.com-search-text-in-string].
- Removing white space is [built-in][tutorial-docs.microsoft.com-trim-white-space].

## 2. Get log level from a log line

- Changing a `string`'s casing is explored in [this tutorial][tutorial-docs.microsoft.com-changing-case].

## 3. Reformat a log line

- There are several ways to [concatenate strings][tutorial-docs.microsoft.com-concatenate-strings], but the preferred one is usually [string interpolation][tutorial-csharp.net-string-interpolation].

[docs-string-methods]: https://docs.microsoft.com/en-us/dotnet/api/system.string
[tutorial-docs.microsoft.com-search-text-in-string]: https://docs.microsoft.com/en-us/dotnet/csharp/how-to/search-strings#where-does-the-sought-text-occur-in-a-string
[tutorial-docs.microsoft.com-trim-white-space]: https://docs.microsoft.com/en-us/dotnet/csharp/how-to/modify-string-contents#trim-white-space
[tutorial-docs.microsoft.com-changing-case]: https://docs.microsoft.com/en-us/dotnet/standard/base-types/changing-case
[tutorial-docs.microsoft.com-concatenate-strings]: https://docs.microsoft.com/en-us/dotnet/csharp/how-to/concatenate-multiple-strings
[tutorial-csharp.net-strings]: https://csharp.net-tutorials.com/data-types/strings/
[tutorial-csharp.net-string-interpolation]: https://csharp.net-tutorials.com/operators/the-string-interpolation-operator/